<?php
namespace App\Models;
use Illuminate\Database\Eloquent\Model;

class Gorgias extends Model {

    private $gorgiasUserName;
    private $gorgiasPassword;
    private $gorgiasUrl;
    private $authorizationToken;

    function __construct() {

        $this->gorgiasUserName = env('GORGIAS_USERNAME', true);
        $this->gorgiasPassword = env('GORGIAS_PASSWORD',true);
        $this->authorizationToken = env('GORGIAS_USERNAME', true).":".env('GORGIAS_PASSWORD',true);
        $this->authorizationToken = base64_encode($this->authorizationToken);
        $this->gorgiasUrl = env('GORGIAS_URL',true);
    }

    /**
     * Create a ticket in Gorgias
     */
    public function createGorgiasTicket($data) {

        $method = 'POST';
        $path = $this->gorgiasUrl;
        $response = $this->call($method, $path, $data);
        return json_decode($response);
    }

    /**
     * CURL call
     */
    function call($method, $path, $data = []) {

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $path);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_ENCODING, '');
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_TIMEOUT, 30);
        curl_setopt($curl, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $method);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
            "Accept:application/json",
            "Authorization:Basic ".$this->authorizationToken,
            "Content-Type:application/json"
        ));

        if ($method !== 'GET') {
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
        }

        $response = curl_exec($curl);
        return $response;
    }
}
