<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::group(['middleware'], function () {

    Route::post('/quiz/storeQuizResponse', 'QuizController@storeQuiz');

    Route::get('/draft-order/Creation', 'DraftOrderController@createDraftOrder');

    Route::get('/order/Creation', 'DraftOrderController@createOrder');

    Route::post('saveOrder', 'DraftOrderController@saveOrder');
    //Route::get('/draft-order/Creation', 'DraftOrderController@show');
    Route::post('/create', 'DraftOrderController@create');

    Route::delete('/quiz/deleteQuiz', [
        'middleware' => 'token.auth',
        'uses' => 'QuizController@deleteQuiz']);

    Route::post('/quiz/getQuizzes', [
        'middleware' => 'token.auth',
        'uses' => 'QuizController@getQuizzes']);

    Route::post('/quiz/getQuizDetails', [
        'middleware' => 'token.auth',
        'uses' => 'QuizController@getQuizDetails']);

    Route::post('/quiz/getRecommendation', [
        'middleware' => 'token.auth',
        'uses' => 'QuizController@getRecommendation']);

    Route::post('/quiz/getQuizRecommendation', [
        //'middleware' => 'token.auth',
        'uses' => 'QuizController@getQuizRecommendation']);

    Route::get('/quiz/getEncryptedDetails', [
        //'middleware' => 'token.auth',
        'uses' => 'QuizController@getEncryptedDetails']);

    // Route::post('/quiz/retakeQuiz', [
    //     'middleware' => 'token.auth',
    //     'uses' => 'QuizController@retakeQuiz']);

    // Route::post('/quiz/retakeQuiz', [
    //         // 'middleware' => 'token.auth',
    //         'uses' => 'QuizController@newRetakeQuiz']);

    Route::post('/quiz/retakeQuiz', [
        // 'middleware' => 'token.auth',
        'uses' => 'QuizController@updatedRetakeQuiz']);

    // Route::get('/quiz/updateRecommendationDataToIterable', 'QuizController@updateRecommendationDataToIterable');

    Route::post('/webhook/setCustomerToken', 'CustomerCreationWebhookController@processWebhook');

    Route::post('/quiz/exitQuizTag', 'QuizController@addExitTag');

    Route::post('/quiz/getPackCount', 'QuizController@getPackCount');

    Route::get('/quiz/sendMailNotification', 'MailController@sendMail');

    Route::post('/newsletter/prospectNotification', 'MailController@sendProspectNotification');

    Route::post('/customer/getActivationUrl', 'CustomerController@getActivationUrl');

    Route::post('/customer/getCustomerStatus', 'CustomerController@getCustomerActivationStatus');

    Route::get('/createOrder', 'OrderController@saveOrder');

    Route::post('/webhook/tagOrder', 'OrderTaggingWebhookController@processWebhook');

    Route::post('/quiz/updatePassword', 'QuizController@updateCustomerPassword');

    Route::post('/quiz/getResumeQuizDetails', 'QuizController@getResumeQuizDetails');

    Route::post('/quiz/updatePasswordTag', 'QuizController@updatePasswordTag');

    Route::post('/quiz/getCustomerDetails', 'QuizController@getCustomerDetails');

    Route::post('/quiz/updateResetPassword', 'QuizController@updateResetPassword');

    Route::post('/quiz/sendCustomPasswordResetEmail', 'QuizController@sendCustomPasswordResetEmail');

    Route::get('/quiz/getCustomerActivationStatus', 'QuizController@getCustomerActivationStatus');
    
    Route::post('/common/createCustomer', 'CommonController@createShopifyCustomer');

    Route::get("/abandonedCart", "IterableController@sendRequest");
    
    Route::post('/webhook/shipmentTracking', 'ShipmentTrackingWebhookController@processWebhook');
    
    Route::get('/customer/getRechargeHash', 'CustomerController@getRechargeHash');
    
    Route::get('/customer/getCustomerStanding', 'CustomerController@getCustomerStanding');

    Route::post('/order/processOrderCancel', 'ShopifyOrderProcessController@processOrderCancel');

    Route::post('/order/processOrderReroute', 'ShopifyOrderProcessController@processOrderReroute');

    Route::get('/order/getOrderExtractedTagStatus', 'ShopifyOrderProcessController@getOrderExtractedTagStatus');

    Route::get('/getAllSubscriptions', 'giftPackController@getAllSubscriptions');

    Route::post('/setGiftRecipientOrderShipDate', 'giftPackController@setGiftRecipientOrderShipDate');

    Route::get('/gifteePauseSubscription', 'giftPackController@gifteePauseSubscription');

    Route::get('/gifteeCancelSubscription', 'giftPackController@gifteeCancelSubscription');

    Route::get('/gifteeSubscriptionAddressUpdate', 'giftPackController@gifteeSubscriptionAddressUpdate');

    Route::post('/createGiftRecipientCheckout', 'giftPackController@createGiftRecipientCheckout');

    Route::post('/quiz-cart-offload', 'quizCartOffLoadController@quizCartOffload');

    Route::get('/getAllSubscriptionsv2', 'SubscriptionsAndOrderHandlingController@getAllSubscriptionsv2');

    Route::get('/getAllSubscriptionsv3', 'SubscriptionsAndOrderHandlingV3Controller@getAllSubscriptionsv3');

    Route::get('/getAllSubscriptionsv4', 'SubscriptionsAndOrderHandlingV4Controller@getAllSubscriptionsv4');

    Route::get('/getGiftRecipientPasswordResetStatus', 'giftPackController@getGiftRecipientPasswordResetStatus');

    Route::post('/orderStatusNotificationTriggering', 'ShopifyOrderDeliveryNotificationController@orderStatusNotificationTriggering');

    Route::post('/cancelAndRefundAutomatedOrder', 'AutomatedOrderHandlingController@cancelAndRefundAutomatedOrder');


    Route::any('{url?}/{sub_url?}', function () {

        $urlList = [
            '/quiz/storeQuizResponse',
            '/quiz/deleteQuiz',
            '/quiz/getQuizzes',
            '/quiz/getQuizDetails',
            '/webhook/setCustomerToken',
            '/quiz/getRecommendation',
            '/quiz/retakeQuiz',
            '/quiz/exitQuizTag',
            '/quiz/getPackCount',
            'newsletter/prospectNotification',
            '/quiz/getQuizRecommendation',
            '/quiz/getEncryptedDetails',
            '/quiz/updatePassword',
            '/quiz/getResumeQuizDetails',
            '/quiz/sendCustomPasswordResetEmail',
            '/common/createCustomer',
            '/webhook/shipmentTracking',
            '/customer/getRechargeHash',
            '/customer/getCustomerStanding',
            '/order/processOrderCancel',
            '/order/processOrderReroute',
            '/order/getOrderExtractedTagStatus',
            '/setGiftRecipientOrderShipDate',
            '/createGiftRecipientCheckout',
            '/getAllSubscriptions',
            '/gifteePauseSubscription',
            '/gifteeCancelSubscription',
            '/gifteeSubscriptionAddressUpdate',
            '/quiz-cart-offload',
            '/getAllSubscriptionsv2',
            '/getAllSubscriptionsv3',
            '/getAllSubscriptionsv4',
            '/getGiftRecipientPasswordResetStatus',
            '/orderStatusNotificationTriggering',
            '/cancelAndRefundAutomatedOrder'
        ];

        $domain = substr(Request::root(), 0);

        $url = Request::url();

        $urlPath = str_replace($domain, "", $url);

        if (in_array($urlPath, $urlList)) {
            return response()->json([
                'status' => 600,
                'message' => 'error',
                'body' => [
                    'error' => 'Malformed Request',
                ],
            ]);
        } else {
            return response()->json([
                'status' => 404,
                'message' => 'error',
                'body' => [
                    'error' => 'Route not found',
                ],
            ]);
        }

    });

    Route::fallback(function () {

        return response()->json([
            'status' => 404,
            'message' => 'error',
            'body' => [
                'error' => 'Route not found',
            ],
        ]);
    });
});
